part of 'app_test.dart';

Future<void> _setUpLogged() async {
  setUp(() async {
    await initializeApp();
    await StorageHelper() //
        .set(SecureStorageKey.isLogged.value, 'true');
    await StorageHelper() //
        .set(SecureStorageKey.haveLocal.value, 'true');
    await StorageHelper() //
        .set(ProfileStorageKey.devUUID.key, 'b5c3818753e76d85');
    await StorageHelper() //
        .set(ProfileStorageKey.userUUID.key, '649c45d7514a28.85876308');
    await StorageHelper() //
        .set(ProfileStorageKey.clientUUID.key, '7');
    await StorageHelper() //
        .set(SecureStorageKey.email.value, 'email_app@exemplo.com');
    await StorageHelper() //
        .set(SecureStorageKey.password.value, '123456');
    await StorageHelper() //
        .set(LocalsStorageKey.isNewVersion.key, true);
    await PhpGroup.resopndeVinculo.call(tarefa: 'A');
    await LicenseRepositoryImpl().resetLicense();
  });
}

Future<void> _setUpUnlogged() async {
  setUp(() async {
    await initializeApp();
    await StorageHelper() //
        .set(SecureStorageKey.isLogged.value, 'false');
    await StorageHelper() //
        .set(SecureStorageKey.haveLocal.value, 'false');
    await StorageHelper() //
        .set(ProfileStorageKey.devUUID.key, '');
    await StorageHelper() //
        .set(ProfileStorageKey.userUUID.key, '');
    await StorageHelper() //
        .set(ProfileStorageKey.clientUUID.key, '');
    await StorageHelper() //
        .set(SecureStorageKey.email.value, '');
    await StorageHelper() //
        .set(SecureStorageKey.password.value, '');
    await StorageHelper() //
        .set(LocalsStorageKey.isNewVersion.key, true);
  });
}

Future<void> _tearDownAll() async {
  tearDownAll(() async {
    await StorageHelper().clean(Storage.databaseStorage);
    await StorageHelper().clean(Storage.secureStorage);
    await StorageHelper().clean(Storage.sharedPreferences);
  });
}

Future<void> _tearDown() async {
  tearDown(() async {
    await StorageHelper().clean(Storage.databaseStorage);
    await StorageHelper().clean(Storage.secureStorage);
    await StorageHelper().clean(Storage.sharedPreferences);
  });
}

Future<void> _setUpAllLogged() async {
  setUpAll(() async {
    await initializeApp().then((_) async {
      await StorageHelper() //
          .set(SecureStorageKey.isLogged.value, 'true');
      await StorageHelper() //
          .set(SecureStorageKey.haveLocal.value, 'true');
      await StorageHelper() //
          .set(ProfileStorageKey.devUUID.key, 'b5c3818753e76d85');
      await StorageHelper() //
          .set(ProfileStorageKey.userUUID.key, '649c45d7514a28.85876308');
      await StorageHelper() //
          .set(ProfileStorageKey.clientUUID.key, '7');
      await StorageHelper() //
          .set(SecureStorageKey.email.value, 'email_app@exemplo.com');
      await StorageHelper() //
          .set(SecureStorageKey.password.value, '123456');
      await StorageHelper() //
          .set(LocalsStorageKey.isNewVersion.key, true);
      await PhpGroup.resopndeVinculo.call(tarefa: 'A');
    });
    await LicenseRepositoryImpl().resetLicense();
  });
}

Future<void> _setUpAllUnlogged() async {
  setUpAll(() async {
    await initializeApp().then((_) async {
      await StorageHelper() //
          .set(SecureStorageKey.isLogged.value, 'false');
      await StorageHelper() //
          .set(SecureStorageKey.haveLocal.value, 'false');
      await StorageHelper() //
          .set(ProfileStorageKey.devUUID.key, '');
      await StorageHelper() //
          .set(ProfileStorageKey.userUUID.key, '');
      await StorageHelper() //
          .set(ProfileStorageKey.clientUUID.key, '');
      await StorageHelper() //
          .set(SecureStorageKey.email.value, '');
      await StorageHelper() //
          .set(SecureStorageKey.password.value, '');
      await StorageHelper() //
          .set(LocalsStorageKey.isNewVersion.key, true);
    });
  });
}

Future<void> _navigateToSignIn(WidgetTester tester) async {
  await tester.pumpAndSettle();
  final Finder navToSignIn =
      find.byKey(const ValueKey<String>('toggleSignInPage'));
  await tester.pumpAndSettle();
  expect(navToSignIn, findsOneWidget);
  await tester.pumpAndSettle();
  if (navToSignIn.evaluate().isNotEmpty) {
    await tester.tap(navToSignIn);
    await tester.pumpAndSettle();
  }
}

Future<void> _navigateToSignUp(WidgetTester tester) async {
  await tester.pumpAndSettle();
  final Finder navToSignUp =
      find.byKey(const ValueKey<String>('toggleSignUpPage'));
  await tester.pumpAndSettle();
  if (navToSignUp.evaluate().isNotEmpty) {
    await tester.tap(navToSignUp);
    await tester.pumpAndSettle();
  }
}

Future<void> _navigateBackUsingSystemGesture() async =>
    IntegrationTestWidgetsFlutterBinding.instance.keyboard
        .isLogicalKeyPressed(LogicalKeyboardKey.escape);
